<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Companies</title>
    <style>
        * {
            font-family: Calibri;
        }

        table {
            width: 80%;
            border: 1px solid darkblue;
            text-align: center;
        }

        table>tbody>tr>td {
            border: 1px solid darkblue;
        }
    </style>
</head>

<body>
    <h1>Eesti börsiettevõtted</h1>

    <table>
        <thead>
            <tr>
                <th>Nimi</th>
                <th>Asutatud</th>
                <th>Töötajaid</th>
            </tr>
        </thead>
        <tbody id="companiesTableBody">
        </tbody>
    </table>
    <br>
    <h2>Lisa uus ettevõte</h2>
    Nimi:<br>
    <input type="text" id="companyName"><br>
    Asutatud:<br>
    <input type="date" id="companyEstablished"><br>
    Töötajate arv:<br>
    <input type="number" id="companyEmployees"><br>
    <button onclick="postCompany()">Salvesta</button>

    <script>
        async function getCompanies() {
            let result = await fetch('http://192.168.55.113:8101/companies');
            let companies = await result.json();
            displayCompanies(companies);
        }

        function displayCompanies(companies) {
            let companiesHtml = '';
            for(let i = 0; i < companies.length; i++) {
                companiesHtml = companiesHtml + `
                    <tr>
                        <td>${companies[i].name}</td>
                        <td>${companies[i].established}</td>
                        <td>${companies[i].employees}</td>
                    </tr>
                `;
            }
            document.querySelector('#companiesTableBody').innerHTML = companiesHtml;
        }

        getCompanies();

        // function callback1(){
        //     console.log("I am callback 1.");
        // }

        // function callback2(){
        //     console.log("I am callback 2.");
        // }

        // function callbackExecutor(text, callbackToExecuteAfterPrintingOutText) {
        //     console.log("Printing out a text...");
        //     console.log(text);

        //     callbackToExecuteAfterPrintingOutText();
        // }

        // callbackExecutor("See tekst tuleb välja printida!", callback1);
        // callbackExecutor("See tekst tuleb välja printida!", function() { console.log(';=ewres'); });

        async function postCompany() {
            let company = {
                name: document.querySelector('#companyName').value,
                established: document.querySelector('#companyEstablished').value,
                employees: document.querySelector('#companyEmployees').value
            };
            let companyJson = JSON.stringify(company);
            
            await fetch('http://192.168.55.113:8101/companies', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json'
                },
                body: companyJson
            });
            getCompanies();
        }

    </script>
</body>

</html>